include:
  remote: 'https://gitlab.com/arbetsformedlingen/devops/gitlab-cicd/jobtech-ci/-/raw/master/security.yml'

stages:
  - lint
  - test
  - deploy

lint_open-api:
  stage: lint
  image: node:lts-alpine
  before_script:
    - npm install -g @quobix/vacuum
  script:
    - vacuum lint --ruleset ./rulesets/openapi-ruleset.yaml --details --errors ./openapi.yaml

lint_json-schemas:
  stage: lint
  image: node:lts-alpine
  before_script:
    - npm install -g ajv-cli
  script:
    - ajv compile --spec=draft2020 --strict=false -s ./**/*.schema.json

bump-version-dry-run:
  stage: deploy
  when: manual
  image: node:22
  variables:
    GIT_DEPTH: 999
  before_script:
    - git fetch
    - git checkout $CI_COMMIT_REF_NAME
    - npm i -g commit-and-tag-version@12.4.1
    - git config --global user.name "Bump version bot"
    - git config --global user.email "bump-version-bot@jobtechdev.se"
    - git remote set-url origin "https://BUMP_VERSION_ACCESS_TOKEN:${BUMP_VERSION_ACCESS_TOKEN}@${CI_REPOSITORY_URL#*@}"
  script:
    - npx commit-and-tag-version --dry-run --packageFiles openapi.yaml --bumpFiles openapi.yaml

bump-version:
  stage: deploy
  only:
    - main
  when: manual
  image: node:22
  variables:
    GIT_DEPTH: 999
  before_script:
    - git fetch
    - git checkout $CI_COMMIT_REF_NAME
    - npm i -g commit-and-tag-version@12.4.1
    - git config --global user.name "Bump version bot"
    - git config --global user.email "bump-version-bot@jobtechdev.se"
    - git remote set-url origin "https://BUMP_VERSION_ACCESS_TOKEN:${BUMP_VERSION_ACCESS_TOKEN}@${CI_REPOSITORY_URL#*@}"
  script:
    - npx commit-and-tag-version --packageFiles openapi.yaml --bumpFiles openapi.yaml
    - git push --follow-tags origin main
